-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt
-----
-- by @MegaKnight
-----

local M = {}


-- checks passed vehicle object for unicycle or simplified traffic 
	--> supports AgentMooshroom's Traffic Pack
local function isSimplifiedOrUnicycle(vehicle)
	local bool = false
	if core_vehicle_manager.getVehicleData(vehicle:getId()).mainPartName == "unicycle" then
		bool = true
	elseif core_vehicle_manager.getVehicleData(vehicle:getId()).mainPartName == "simple_traffic" then
		bool = true
	elseif core_vehicle_manager.getVehicleData(vehicle:getId()).mainPartName == "agent_traffic_eunew1" then
		bool = true
	elseif core_vehicle_manager.getVehicleData(vehicle:getId()).mainPartName == "agent_traffic_eu2" then
		bool = true
	elseif core_vehicle_manager.getVehicleData(vehicle:getId()).mainPartName == "agent_traffic_yakuza" then
		bool = true
	end
	return bool
end


-- applies wind to vehicle
local function applyWind(vehicle, forceVec)
	-- check for unicycle & simplified traffic --> reduced weight
	if isSimplifiedOrUnicycle(vehicle) then
		vehicle:queueLuaCommand('obj:setWind(' .. (forceVec.x * 0.5) .. ',' .. (forceVec.y * 0.5) .. ',' .. (forceVec.z * 0.5) .. ')')
	else
		vehicle:queueLuaCommand('obj:setWind(' .. forceVec.x .. ',' .. forceVec.y .. ',' .. forceVec.z .. ')')
	end
end


-- applies wind to all vehicles
local function applyWindAll(forceVec)
	-- iterate over all vehicles
	for i = 0, (be:getObjectCount() - 1) do
		local vehicle = be:getObject(i)
		-- check for unicycle & simplified traffic --> reduced weight
		if isSimplifiedOrUnicycle(vehicle) then
			vehicle:queueLuaCommand('obj:setWind(' .. (forceVec.x * 0.5) .. ',' .. (forceVec.y * 0.5) .. ',' .. (forceVec.z * 0.5) .. ')')
		else
			vehicle:queueLuaCommand('obj:setWind(' .. forceVec.x .. ',' .. forceVec.y .. ',' .. forceVec.z .. ')')
		end
	end
end


--local function onExtensionUnloaded()
--end

--local function onExtensionLoaded()
--	log("I", "", "Common Library Loaded")
--	applyWind(getPlayerVehicle(0), Point3F(100,100,100))
--end


-- public interface
M.applyWind = applyWind
M.applyWindAll = applyWindAll

--M.onExtensionLoaded = onExtensionLoaded


return M